#!/bin/sh

gawk --file ./kbde.awk --source '

function convert_code(String)
{
   if (String ~ "-NONE-") return "";

   # Be sure we have leading white-space
   String = " " String
   # Replace white-spaces seq to "\\x"
   gsub("[[:blank:]]+", "\\x", String);
   return String
}

function print_define()
{
   for (Define = 1; int(Define) <= int(MaxDefine); Define = Define + 1) {
      Name = Names[Define];
      if (Name != "") {
         Make  = convert_code(Makes[Define]);
         Break = convert_code(Breaks[Define]);
         printf "#define %s%s       %s\n"    , Define_Prefix, Name, Define;
         printf "#define %s%s_MAKE  \"%s\"\n", Define_Prefix, Name, Make;
         printf "#define %s%s_BREAK \"%s\"\n", Define_Prefix, Name, Break;
         printf "\n"
      }
   }
   printf "#define %s%s       %s\n", Define_Prefix, "LAST_USED", MaxDefine;
   printf "\n";
}

function print_func()
{
   print_define();
}
' || exit
exit 0
